#!/usr/bin/perl

use diagnostics;
use lib "..";
use HotSaNIC;

# read global settings
#
$MODNAME=lc get_module_name();

%CONFIG=get_config("..");
$IMAGEFORMAT=$CONFIG{"IMAGEFORMAT"};
$REFRESH=$CONFIG{"REFRESH"};
$REFRESH=0 if !defined $REFRESH;

# read module-specific settings
#
@DEVS=("rc5","ogr","des","csc");
@DIAGRAMS=("week","month","year");
@TIMES=("month","year");

# build time-based .html files
#
foreach $time (@TIMES) {
  open (FILE,">index/$time.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n<table>\n";
  foreach $dev (@DEVS) {
    print FILE "  <tr><td><a href=\"",$dev,".html\"><img src=\"",$dev,"-",$time,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"",$dev,".html\"><h2>",$dev,"</h2></a></td></tr>\n";
    }
  print FILE "</table>\n</body>\n</html>\n";
  close FILE;
  }

# build device-based .html files and complete index
#
open (IDXFILE,">idxdata");
print IDXFILE "0##    <td colspan=2 align=center valign=top> <font size=\"+3\">",$MODNAME,"</font><br>
0##      <a href=\"",$MODNAME,"/month.html\">month</a>
0##      <a href=\"",$MODNAME,"/year.html\">year</a>
0##      </td>\n";
$nn=0;
foreach $dev (@DEVS) {
  $nn++;
  print IDXFILE $nn,"##    <td><a href=\"",$MODNAME,"/",$dev,".html\"><img src=\"",$MODNAME,"/thumb-",$dev,".",$IMAGEFORMAT,"\"></a></td>
$nn##    <td valign=top><a href=\"",$MODNAME,"/",$dev,".html\">",$dev,"</a></td>\n";

# build device-based .html
#
  open (FILE,">index/$dev.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n";
  foreach $diagram (@DIAGRAMS) {
    print FILE "<img src=\"",$dev,"-",$diagram,".",$IMAGEFORMAT,"\">\n";
    }
  print FILE "</body>\n</html>\n";
  close FILE;
  }

close IDXFILE;

