#!/usr/bin/perl

use RRDs;
use lib "..";
use HotSaNIC;

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

# read module-specific settings
#
open (FILE,"settings") or dupe_control("die",$ARGS{"MODNAME"},": error - $!");
while (<FILE>) {
  ($var,$value)=parse_line($_);
  if ($var eq "IPTABLES") { $IPTABLES=$value; last; }
  }
close FILE;

if ( ! defined $IPTABLES) { dupe_control("die",$ARGS{"MODNAME"},"IPTABLES not configured in module settings..."); }

%acct_int_old=readfile("acct_int.dat");
%acct_ext_old=readfile("acct_ext.dat");

system("$IPTABLES -L acct_int -xvn > acct_int.dat");
system("$IPTABLES -L acct_ext -xvn > acct_ext.dat");

%acct_int=readfile("acct_int.dat");
%acct_ext=readfile("acct_ext.dat");

$time=time;

foreach $nn (sort(keys(%acct_int))) {
  $allin=$acct_int{$nn}[1]-$acct_int_old{$nn}[1];
  $tcpin=$acct_int{$nn}[3]-$acct_int_old{$nn}[3];
  $udpin=$acct_int{$nn}[5]-$acct_int_old{$nn}[5];
  $icmpin=$acct_int{$nn}[7]-$acct_int_old{$nn}[7];
  $allout=$acct_int{$nn}[2]-$acct_int_old{$nn}[2];
  $tcpout=$acct_int{$nn}[4]-$acct_int_old{$nn}[4];
  $udpout=$acct_int{$nn}[6]-$acct_int_old{$nn}[6];
  $icmpout=$acct_int{$nn}[8]-$acct_int_old{$nn}[8];
  updatedb($time,"int$nn",$tcpin,$udpin,$icmpin,$tcpout,$udpout,$icmpout);
  }

foreach $nn (sort(keys(%acct_ext))) {
  $allin=$acct_ext{$nn}[1]-$acct_ext_old{$nn}[1];
  $tcpin=$acct_ext{$nn}[3]-$acct_ext_old{$nn}[3];
  $udpin=$acct_ext{$nn}[5]-$acct_ext_old{$nn}[5];
  $icmpin=$acct_ext{$nn}[7]-$acct_ext_old{$nn}[7];
  $allout=$acct_ext{$nn}[2]-$acct_ext_old{$nn}[2];
  $tcpout=$acct_ext{$nn}[4]-$acct_ext_old{$nn}[4];
  $udpout=$acct_ext{$nn}[6]-$acct_ext_old{$nn}[6];
  $icmpout=$acct_ext{$nn}[8]-$acct_ext_old{$nn}[8];
  updatedb($time,"ext$nn",$tcpin,$udpin,$icmpin,$tcpout,$udpout,$icmpout);
  }

dupe_control("stop",$ARGS{"MODNAME"},"");

sub readfile {
  my $file=shift;
  my $ip="";
  undef %hash;
  open (FILE,$file);
  while (<FILE>) {
    chomp;
    if (index($IPTABLES,"ipchains") >= 0 ) {
      ($pkt,$bytes,$target,$proto,$opt,$tosa,$tosx,$ifname,$src,$dst)=split;
      }
    else {
      ($pkt,$bytes,$target,$proto,$opt,$in,$out,$src,$dst)=split;
      }
    if ($dst eq "") { ($proto,$opt,$in,$out,$src,$dst)=($target,$proto,$opt,$in,$out,$src); }
    if ($src eq "0.0.0.0/0") { $ip=$dst;$dir=1; } elsif ($dst eq "0.0.0.0/0") { $ip=$src;$dir=0; }
    if ($proto eq "all") { $prt=1 };
    if ($proto eq "tcp") { $prt=3 };
    if ($proto eq "udp") { $prt=5 };
    if ($proto eq "icmp") { $prt=7 };
    if ($ip ne "") {$hash{"$ip"}[$prt+$dir]=$bytes;}
    }
  close (FILE);
  return %hash;
  }

# update database
sub updatedb {
  my ($time,$name,$tcpin,$udpin,$icmpin,$tcpout,$udpout,$icmpout)=@_;
  $name =~ s/\//_/g;
  if ( !-e "rrd/$name.rrd") { system "./makerrd $name U"; }
  RRDs::update "rrd/$name.rrd",$time.":".$tcpin.":".$udpin.":".$icmpin.":".$tcpout.":".$udpout.":".$icmpout."\n";
  if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update `$name.rrd': $ERROR"); }
  }

