#!/usr/bin/perl

use lib "..";
use HotSaNIC;

# read global settings
#
$MODNAME=lc get_module_name();

%CONFIG=get_config("..");
$IMAGEFORMAT=$CONFIG{"IMAGEFORMAT"};
$REFRESH=$CONFIG{"REFRESH"};
$REFRESH=0 if !defined $REFRESH;

# read module-specific settings
#
undef %DEVS;
open (FILE,"settings") or die (uc $MODNAME,": error - $!");
while (<FILE>) {
  ($var,$value)=parse_line($_);
  if ($var eq "DRIVE") {
    ($dev,$name)=split(/,/,$value);
    $DEVS{$dev}=$name;
    }
  }
close FILE;
@DIAGRAMS=("day","week","month","year");
@TIMES=("week");

# build time-based .html files
#
foreach $time (@TIMES) {
  open (FILE,">index/$time.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n<table>\n";
  foreach $dev (keys(%DEVS)) {
    $name=$DEVS{$dev};
    $file=$dev;
    $file=~ s/:\//__/g;
    $file=~ s/\//_/g;
    print FILE"  <tr><td><a href=\"",$file,".html\"><img src=\"",$file,"-",$time,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"",$file,".html\"><h2>",$dev,"</h2></a><br>",$name,"</td></tr>\n";
    }
  print FILE "</table>\n</body>\n</html>\n";
  close FILE;
  }

# build device-based .html files and complete index
#
open (IDXFILE,">idxdata");
print IDXFILE "0##    <td colspan=2 align=center valign=top> <font size=\"+3\">",$MODNAME,"</font><br>
0##      <a href=\"",$MODNAME,"/week.html\">week</a>
0##      </td>\n";
$nn=0;
foreach $dev (keys(%DEVS)) {
  $nn++;
  $name=$DEVS{$dev};
  $file=$dev;
  $file=~ s/:\//__/g;
  $file=~ s/\//_/g;
  print IDXFILE $nn,"##    <td><a href=\"",$MODNAME,"/",$file,".html\"><img src=\"",$MODNAME,"/thumb-",$file,".",$IMAGEFORMAT,"\"></a></td>
",$nn,"##    <td valign=top><a href=\"",$MODNAME,"/",$file,".html\">",$dev,"<br></a><font size=\"-2\">",$name,"</font></td>\n";

# build device-based .html
#
  open (FILE,">index/$file.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n";
  foreach $diagram (@DIAGRAMS) { 
    print FILE "<img src=\"",$file,"-",$diagram,".",$IMAGEFORMAT,"\">\n";
    }
  print FILE "</body>\n</html>\n";
  close FILE;
  }

close IDXFILE;

