#!/usr/bin/perl

use lib "..";
use HotSaNIC;

# read global settings
#
$MODNAME=lc get_module_name();

%CONFIG=get_config("..");
$IMAGEFORMAT=$CONFIG{"IMAGEFORMAT"};
$REFRESH=$CONFIG{"REFRESH"};
$REFRESH=0 if !defined $REFRESH;

# read module-specific settings
#
undef %DEVS;
open (FILE,"settings") or die (uc $MODNAME,": error - $!");
while (<FILE>) {
  ($var,$value)=parse_line($_);
  if ($var eq "HOST") {
    ($ip,$name)=split(/,/,$value);
    $DEVS{$ip}=$name;
    }
  }
close FILE;
@DIAGRAMS=("hour","6h","day","week","month","year");
@TIMES=("6h","week");

# build time-based .html files
#
foreach $time ("6h","week") {
  open (FILE,">index/$time.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n<table>\n";
  foreach $dev (sort keys(%DEVS)) {
    $name=$DEVS{$dev};
    if ( $name eq "" ) { $name=$dev; }
    print FILE "  <tr><td><a href=\"",$dev,".html\"><img src=\"",$dev,"-",$time,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"",$dev,".html\"><h2>",$dev,"</h2></a><br>",$name,"</td></tr>\n";
    }
  print FILE "</table>\n</body>\n</html>\n";
  close FILE;
  }

# build device-based .html files and complete index
#
open (IDXFILE,">idxdata");
print IDXFILE "0##    <td colspan=2 align=center valign=top> <font size=\"+3\">",$MODNAME,"</font><br>
0##      <a href=\"",$MODNAME,"/6h.html\">6 hours</a>
0##      <a href=\"",$MODNAME,"/week.html\">week</a>
0##      </td>\n";
$nn=0;
foreach $dev (sort keys(%DEVS)) {
  $nn++;
  $name=$DEVS{$dev};
  if ( $name eq "" ) { $name=$dev; }

  print IDXFILE $nn,"##    <td><a href=\"",$MODNAME,"/",$dev,".html\"><img src=\"",$MODNAME,"/thumb-",$dev,".",$IMAGEFORMAT,"\"></a></td>
",$nn,"##    <td valign=top><a href=\"",$MODNAME,"/",$dev,".html\">",$dev,"</a><br><font size=\"-2\">",$name,"</font></td>\n";

# build device-based .html
#
  open (FILE,">index/$dev.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n";
  foreach $diagram (@DIAGRAMS) {
    print FILE "<img src=\"",$dev,"-",$diagram,".",$IMAGEFORMAT,"\">\n";
    }
  print FILE "</body>\n</html>\n";
  close FILE;
  }

close IDXFILE;

