#!/usr/bin/perl -w

use lib "..";
use HotSaNIC;
use RRDs;

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

# read module-specific settings
#

open (FILE,"settings");
while (<FILE>) {
  ($var,$value)=parse_line($_);
  if ($var eq "HOST") {
    ($ip)=split(/,/,$value);
    push @HOSTS,$ip;
    next;
    }
  if ($var eq "INTERVAL") { $interval=$value; }
  }

(undef,undef,undef,undef,undef,undef,undef,undef,undef,$mtime,undef,undef,undef)=stat("rrd");
$now=time;

if ((($mtime+$interval) > $now) && ($mtime+5 < $now)) { dupe_control("stop",$ARGS{"MODNAME"},""); }
utime $now,$now,"rrd";

$|=1;

foreach $host (@HOSTS) {
  fork && next;
  $result=ping($host,250,250,10);

  ($min,$avg,$max)=split(/\//,$result);
  if ( ! -e "rrd/$host.rrd" ) { system("./makerrd","$host","U") }
  RRDs::update "rrd/$host.rrd",time.":".$min.":".$avg.":".$max;
  if ($ERROR = RRDs::error) { dupe_control("warn",$ARGS{"MODNAME"},"unable to update `$host.rrd': $ERROR"); }

  exit;
  }

# wait for child processes to end
wait;

dupe_control("stop",$ARGS{"MODNAME"},"");

####  Usage:
####     ping ("host or IP",timeout (ms), wait (ms), count);
####
####  Return:
####     min/avg/max (ms)
sub ping {

  require 'sys/syscall.ph';
  use Net::Ping;

  $HOST=shift;
  
  $TIMEOUT=shift;
  if ($TIMEOUT<50) { $TIMEOUT=50; }
  $TIMEOUT/=1000;

  $WAIT=shift;
  $WAIT/=1000;

  $COUNT=shift;
  if ($COUNT<1) { $COUNT=1; }

  $min=10000000; $max=0; $add=0;

  $p = Net::Ping->new("icmp");
  $TIMEVAL_T = "LL";
  $done = $start = pack($TIMEVAL_T, ());

  $replies=0;
  #  $first_reply=$p->ping($HOST, $TIMEOUT);

  for ($i=0; $i < $COUNT ; $i++) {
    
    syscall(&SYS_gettimeofday, $start, 0) != -1 or dupe_control("die",$ARGS{"MODNAME"},": gettimeofday: $!");
    $reply=$p->ping($HOST, $TIMEOUT);
    syscall( &SYS_gettimeofday, $done, 0) != -1 or dupe_control("die",$ARGS{"MODNAME"},": gettimeofday: $!");

    @start = unpack($TIMEVAL_T, $start);
    @done  = unpack($TIMEVAL_T, $done);

    $time=($done[0]-$start[0])*1000 + ($done[1]-$start[1])/1000;
    if ( $reply ) {
      push @timearr,$time;
      $replies++;
      $add+=$time;
      }
    select (undef, undef,undef,$WAIT);
    }

  $p->close();

  $avg=$add/$replies if $replies>0;
  $replies=0;$add=0;
  foreach (@timearr) {
    if ($_ < 3*$avg) {
      $add+=$_;
      $replies++;
      $min=$_ if $_<$min;
      $max=$_ if $_>$max;
      }
    }
  if ($replies eq 0) { $replies++; $min=0; $max=0; $add=0; }
  $avg=$add/$replies;
  return ( "$min/$avg/$max");
  }

