#!/usr/bin/perl

use lib "..";
use HotSaNIC;

# read global settings
#
$MODNAME=lc get_module_name();

%CONFIG=get_config("..");
$IMAGEFORMAT=$CONFIG{"IMAGEFORMAT"};
$REFRESH=$CONFIG{"REFRESH"};
$REFRESH=0 if !defined $REFRESH;

# read module-specific settings
#
undef %SENSOR;
undef %SENSORDB;
open (FILE,"settings") or die (uc $MODNAME,": error - $!");
while (<FILE>) {
  ($var,$value)=parse_line($_);
  if ($var eq "SENSOR") {
    ($dev,$dbname,$name,$num,$scale,$add,$unit)=split(/,/,$value);
    $SENSORDB{$dev}=$dbname;
    $SENSOR{$dev}=$name;
    }
  }
close FILE;
@DIAGRAMS=("hour","6h","day","week","month","year");
@TIMES=("6h","week");

# build time-based .html files
#
foreach $index ("6h","week") {
  open (FILE,">index/$index.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n<table>\n";
  foreach $dev (keys %SENSOR) {
    $dbname=$SENSORDB{$dev};
    $name=$SENSOR{$dev};
    print FILE "  <tr><td><a href=\"",$dbname,".html\"><img src=\"",$dbname,"-6h.",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"",$dbname,".html\"><h2>",$name,"</h2></a></td></tr>\n";
    }
  print FILE "</table>\n</body>\n</html>\n";
  close FILE;
  }

# build device-based .html files and complete index
#
open (IDXFILE,">idxdata");
print IDXFILE "0##    <td colspan=2 align=center valign=top> <font size=\"+3\">",$MODNAME,"</font><br>
0##      <a href=\"",$MODNAME,"/6h.html\">6 hours</a>
0##      <a href=\"",$MODNAME,"/week.html\">week</a>
0##      </td>\n";
$nn=0;
foreach $dev (keys %SENSOR) {
  $nn++;
  $dbname=$SENSORDB{$dev};
  $name=$SENSOR{$dev};
  print IDXFILE $nn,"##    <td><a href=\"",$MODNAME,"/",$dbname,".html\"><img src=\"",$MODNAME,"/thumb-",$dbname,".",$IMAGEFORMAT,"\"></a></td>
",$nn,"##    <td valign=top><a href=\"",$MODNAME,"/",$dbname,".html\">",$name,"</a><br></td>\n";

# build device-based .html
#
  open (FILE,">index/$dbname.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n";
  foreach $diagram (@DIAGRAMS) {
    print FILE "<img src=\"",$dbname,"-",$diagram,".",$IMAGEFORMAT,"\">\n";
    }
  print FILE "</body>\n</html>\n";
  close FILE;
  }

close IDXFILE;

