#!/usr/bin/perl

use lib "..";
use HotSaNIC;

# read global settings
#
$MODNAME=lc get_module_name();

%CONFIG=get_config("..");
$IMAGEFORMAT=$CONFIG{"IMAGEFORMAT"};
$REFRESH=$CONFIG{"REFRESH"};
$REFRESH=0 if !defined $REFRESH;

# read module-specific settings
#

# evaluate number of CPUs
#
opendir DIR,"rrd";
@CPUs=grep /cpu/,readdir DIR;
closedir DIR;
foreach (@CPUs) { chomp; s/\.rrd//g; push @cpu,$_;  }

# build time-based .html files
#
foreach $index ("hour","week") {
  open (FILE,">index/$index.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n<table>
  <tr><td><a href=\"proc.html\"><img src=\"proc-",$index,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"proc.html\"><h2>processes</h2></a></td></tr>
  <tr><td><a href=\"cpu.html\"><img src=\"cpu-",$index,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"cpu.html\"><h2>cpu usage</h2></a></td></tr>
  <tr><td><a href=\"load.html\"><img src=\"load-",$index,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"load.html\"><h2>load</h2></a></td></tr>
  <tr><td><a href=\"mem.html\"><img src=\"mem-",$index,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"mem.html\"><h2>memory</h2></a></td></tr>
  <tr><td><a href=\"swap.html\"><img src=\"swap-",$index,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"swap.html\"><h2>swap</h2></a></td></tr>
  <tr><td><a href=\"users.html\"><img src=\"users-",$index,".",$IMAGEFORMAT,"\"></a></td>
      <td valign=top><a href=\"users.html\"><h2>users</h2></a></td></tr>
</table>\n</body>\n</html>\n";
  close FILE;
  }

open (IDXFILE,">idxdata");
print IDXFILE "0##    <td colspan=2 align=center> <font size=\"+3\">",$MODNAME,"</font><br>
0##      <a href=\"",$MODNAME,"/hour.html\">hour</a>
0##      <a href=\"",$MODNAME,"/week.html\">week</a>
0##      </td>
1##    <td><a href=\"",$MODNAME,"/proc.html\"><img src=\"system/thumb-proc.",$IMAGEFORMAT,"\"></a></td>
1##    <td valign=top><a href=\"",$MODNAME,"/proc.html\">processes</a></td>
2##    <td><a href=\"",$MODNAME,"/cpu.html\"><img src=\"system/thumb-cpu.",$IMAGEFORMAT,"\"></a></td>
2##    <td valign=top><a href=\"",$MODNAME,"/cpu.html\">cpu usage</a></td>
3##    <td><a href=\"",$MODNAME,"/load.html\"><img src=\"system/thumb-load.",$IMAGEFORMAT,"\"></a></td>
3##    <td valign=top><a href=\"",$MODNAME,"/load.html\">load</a></td>
4##    <td><a href=\"",$MODNAME,"/mem.html\"><img src=\"system/thumb-mem.",$IMAGEFORMAT,"\"></a></td>
4##    <td valign=top><a href=\"",$MODNAME,"/mem.html\">memory</a></td>
5##    <td><a href=\"",$MODNAME,"/swap.html\"><img src=\"system/thumb-swap.",$IMAGEFORMAT,"\"></a></td>
5##    <td valign=top><a href=\"",$MODNAME,"/swap.html\">swap</a></td>
6##    <td><a href=\"",$MODNAME,"/users.html\"><img src=\"system/thumb-users.",$IMAGEFORMAT,"\"></a></td>
6##    <td valign=top><a href=\"",$MODNAME,"/users.html\">users</a></td>\n";
close IDXFILE;

foreach $index (@cpu,"mem","proc","load","swap","users") {
  print "writing $index\n";
  open (FILE,">index/$index.html");
  print FILE "<html>\n";
  if ($REFRESH > 0) {
    print FILE "<META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$REFRESH\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    }
  print FILE "<body>\n<img src=\"",$index,"-hour.",$IMAGEFORMAT,"\">\n<img src=\"",$index,"-day.",$IMAGEFORMAT,"\">\n<img src=\"",$index,"-week.",$IMAGEFORMAT,"\">\n";
  if ($index ne "load") { print FILE "<img src=\"",$index,"-month.",$IMAGEFORMAT,"\">\n"; }
  print FILE "<img src=\"",$index,"-year.",$IMAGEFORMAT,"\">\n</body>\n</html>\n";
  close FILE;
  }

